## liboclock-ocaml 0.3

=== Makefile ===
# Copyright (c) 2011, Mickaël Delahaye <mickael.delahaye@gmail.com>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED “AS IS” AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.

OCAMLC ?= ocamlc
OCAMLOPT ?= ocamlopt
OCAMLDEP ?= ocamldep
OCAMLDOC ?= ocamldoc
OCAMLFIND ?= $(shell which ocamlfind > /dev/null && echo ocamlfind)

OCAMLBFLAGS ?=
OCAMLOFLAGS ?=
OCAMLDEPFLAGS ?=

OCAMLLIBDIR ?= $(shell ocamlc -where)
INSTALL_DIR ?= $(OCAMLLIBDIR)/oclock
STUBLIBS_DIR ?= $(OCAMLLIBDIR)/stublibs

################################################################################

OCAMLC += $(OCAMLBFLAGS)
OCAMLOPT += $(OCAMLOFLAGS)
OCAMLDEP += $(OCAMLDEPFLAGS)

CFLAGS ?= -fPIC
CLIBS = rt pthread
# pthread seems necessary with some build of ocaml

export OCAMLC
export OCAMLOPT
export OCAMLDEP

all: byte native

byte: oclock.cma dlloclock.so
native: oclock.cmxa liboclock.a oclock.a

# Generic library compilation
%.cma: %.cmo dll%.so
	$(OCAMLC) -dllib -l$(@:.cma=) $< -a -o $@
%.cmxa: %.cmx lib%.a
	$(OCAMLOPT) $(CLIBS:%=-cclib -l%) -cclib -l$(@:.cmxa=) $< -a -o $@

lib%.a: %_stubs.o
	ar crs $@ $<
dll%.so: %_stubs.o
	$(LD) -shared -o $@ $< -lrt

# Generic Ocaml compilation
%.cmo:%.ml
	$(OCAMLC) -c $<
%.cmi:%.mli
	$(OCAMLC) -c $<
%.cmx:%.ml
	$(OCAMLOPT) -c $<

# Dependencies
.depend:
	$(OCAMLDEP) *.ml *.mli > .depend

-include .depend

# Cleaning
clean:
	$(RM) *.cmo *.cmi *.cmx
	$(MAKE) -C examples clean

distclean: clean
	$(RM) *.cma *.cmxa *.a *.so
	$(MAKE) -C examples distclean

# (Un)Install
install: all
ifdef OCAMLFIND
	$(OCAMLFIND) install oclock oclock.cma oclock.cmxa liboclock.a oclock.cmi oclock.a META -dll dlloclock.so
else
	install -d $(INSTALL_DIR)
	install -t $(INSTALL_DIR) oclock.cma oclock.cmxa liboclock.a oclock.cmi oclock.a META
	install -t $(STUBLIBS_DIR) dlloclock.so
endif

uninstall:
ifdef OCAMLFIND
	$(OCAMLFIND) remove oclock 
else
	$(RM) -r $(INSTALL_DIR)
	$(RM) $(STUBLIBS_DIR)/dlloclock.so
endif

# Documentation

doc:
	mkdir -p doc
	$(OCAMLDOC) -d doc -html -d doc *.mli

# Examples
test examples: all
	$(MAKE) -C examples

# Phony targets
.PHONY: install clean distclean all test examples byte native doc

=== examples/Makefile ===
# Copyright (c) 2011, Mickaël Delahaye <mickael.delahaye@gmail.com>
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED “AS IS” AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
# LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.

OCAMLC ?= ocamlc
OCAMLOPT ?= ocamlopt

OCLOCKPATH = $(shell if which ocamlfind 2>&1 > /dev/null; then \
  ocamlfind query oclock 2> /dev/null; else echo +oclock; fi)
OCAMLC += -I $(OCLOCKPATH)
OCAMLOPT += -I $(OCLOCKPATH)

EXAMPLES=realtime getcputime

all: $(EXAMPLES:%=%.byte) $(EXAMPLES:%=%.opt)

# Generic Ocaml compilation
%.cmo:%.ml
	$(OCAMLC) -c $<
%.cmi:%.mli
	$(OCAMLC) -c $<
%.cmx:%.ml
	$(OCAMLOPT) -c $<

# Generic linking
%.byte:%.cmo
	$(OCAMLC) -o $@ oclock.cma $<
%.opt:%.cmx
	$(OCAMLOPT) -o $@ oclock.cmxa $<

# Cleaning
clean:
	$(RM) *.cmo *.cmi *.cmx *.o
distclean: clean
	$(RM) *.byte *.opt

# Phony targets
.PHONY: clean distclean all

=== debian/changelog ===
liboclock-ocaml (0.3-3) UNRELEASED; urgency=low

  * Split files correctly between base and devel packages

 -- Euan Harris <euan.harris@citrix.com>  Fri, 30 May 2014 12:00:00 +0000

liboclock-ocaml (0.3-2) UNRELEASED; urgency=low

  * Initial package

 -- David Scott <dave.scott@eu.citrix.com>  Wed, 29 May 2013 12:00:00 +0000

=== debian/control ===
Source: liboclock-ocaml
Priority: optional
Maintainer: Euan Harris <euan.harris@citrix.com>
Section: ocaml
Standards-Version: 3.9.3
Build-Depends:
 dh-ocaml (>= 0.9),
 ocaml-nox,
 python,
 debhelper (>= 8),
 ocaml-findlib,
 ocaml-native-compilers

Package: liboclock-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: POSIX monotonic clock for OCaml
 A POSIX monotonic clock for OCaml

Package: liboclock-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 liboclock-ocaml (>= 0.3-3)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: Development files for ocaml-oclock
 The ocaml-oclock-devel package contains libraries and signature files
 for developing applications that use ocaml-oclock.

=== debian/rules ===
#!/usr/bin/make -f

#include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/class/makefile.mk
#include /usr/share/cdbs/1/rules/ocaml.mk

export DH_VERBOSE=1
export DH_OPTIONS
export DESTDIR=$(CURDIR)/debian/tmp
%:
	dh $@ --with ocaml --with python2

.PHONY: override_dh_auto_configure
override_dh_auto_configure:

.PHONY: override_dh_auto_build
override_dh_auto_build:
	debian/build.sh

.PHONY: override_dh_auto_install
override_dh_auto_install:
	debian/install.sh

.PHONY: override_dh_install
override_dh_install:
	dh_install
	rm -f debian/liboclock-ocaml/usr/lib/ocaml/oclock/*.a
	rm -f debian/liboclock-ocaml/usr/lib/ocaml/oclock/*.cmxa

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	debian/clean.sh
	/bin/rm -rf ${DESTDIR}

.PHONY: override_dh_auto_test
override_dh_auto_test:
